﻿this.init = function () {
    var me = this;

    var options = $options;

    var now = new Date(),
        listItems = [],
        incr = 1,
        maxList = 12,
        // display max rows of sidebar
        begin = now.setDate(now.getDate() - 3),
        end = undefined;
    now.setMonth(now.getMonth() + 2)
    end = now.setDate(now.getDate() - 1);
    for (incr = 1; incr <= maxList; incr++) {
        listItems.push('<span>Row ' + incr + '</span>');
    }

    // Timeline options are defined as global variables
    window.tlOpts = {
        type: 'mixed',
        startDatetime: begin,
        endDatetime: end,
        scale: 'day',
        minGridSize: 48,
        headline: {
            display: true,
            title: 'Timeline',
            range: true,
            local: 'en-US',
            format: {
                timeZone: 'UTC',
                hour12: false,
            }
        },
        sidebar: {
            list: listItems,
            sticky: true,
        },
        rows: listItems.length,
        ruler: {
            top: {
                lines: ['year', 'month', 'day'],
                format: {
                    year: 'numeric',
                    month: 'long',
                    day: 'numeric',
                }
            },
            bottom: {
                lines: ['day'],
                format: {
                    day: 'numeric',
                }
            }
        },
        hideScrollbar: true,
        eventData: generateEventData(begin, end),
    };


    //DiNo initialize

    if (this.Timeline == null) {

        this.container.style.backgroundColor = 'pink';

        // create the inner input control.
        var el = this.container;
        var id = this.getId() + "_timeline";
        
        // save a reference to widget.
        this.Timeline = this.widget = $("#" + id);

        // initialize the jQuery widget.
        this.Timeline.Timeline(window.tlOpts);
    }


    function generateEventData(begin, end) {
        // Generate an initial event nodes for the timeline.
        var events = [
            {
                start: getModDateString(begin, {
                    day: '+5',
                    h: 12,
                    min: 34,
                    sec: 56
                }),
                end: getModDateString(begin, {
                    day: '+12',
                    h: 15,
                    min: 43,
                    sec: 21
                }),
                row: 1,
                content: 'Event whose start and end points are within the initial range.',
                label: 'Normal Event Node',
                bdColor: '#EE7800',
                bgColor: '#F2D58A'
            },
            {
                start: getModDateString(begin, {
                    day: '+8',
                    h: 12,
                    min: 34,
                    sec: 56
                }),
                end: getModDateString(begin, {
                    day: '+12',
                    h: 15,
                    min: 43,
                    sec: 21
                }),
                row: 1,
                content: 'Event whose start and end points are within the initial range.',
                label: 'Overlap Event Node',
                bdColor: '#FFDC00',
                bgColor: '#EAEEA2'
            },
            {
                start: getModDateString(begin, {
                    day: '+14',
                    h: 1,
                    min: 23,
                    sec: 45
                }),
                end: getModDateString(end, {
                    month: '+1',
                    h: 23,
                    min: 59,
                    sec: 59
                }),
                row: 2,
                content: 'Event whose endpoint is outside the initial range.',
                label: 'Outrange Startpoint Event Node'
            },
        ];
        return events;
    }


    // Various helper functions
    function getDateArray(date) {
        // Helper to get each elements of Date object as an array
        var _dt = date instanceof Date ? date : new Date(date);
        return [_dt.getFullYear(), _dt.getMonth(), _dt.getDate(), _dt.getHours(), _dt.getMinutes(), _dt.getSeconds(), _dt.getMilliseconds()];
    }
    function getDateString(date) {
        // Helper to get Date object as a string of "Y-m-d H:i:s" format
        var _dt = getDateArray(date);
        // return `${_dt[0]}-${_dt[1] + 1}-${_dt[2]} ${_dt[3]}:${_dt[4]}:${_dt[5]}`;
        return _dt[0] + '-' + (_dt[1] + 1) + '-' + _dt[2] + ' ' + _dt[3] + ':' + _dt[4] + ':' + _dt[5];
    }
    function getModDateString(date, mods) {
        // Helper to get the date string after updating the date with the specified amount time.
        var baseDt = date instanceof Date ? new Date(date.getTime()) : new Date(date),
            getRandomInt = function (min, max) {
                min = Math.ceil(min);
                max = Math.floor(max);
                return Math.floor(Math.random() * (max - min)) + min;
            },
            found;
        if (mods && typeof mods === 'object') {
            for (var _key in mods) {
                found = null;
                switch (true) {
                    case /^y(|ears?)$/i.test(_key):
                        if (typeof mods[_key] === 'string' && /^(-|\+)\d+$/i.test(mods[_key])) {
                            found = mods[_key].match(/^(-|\+)(\d+)$/);
                            if (found[1] === '-') {
                                baseDt.setFullYear(baseDt.getFullYear() - Number(found[2]));
                            } else {
                                baseDt.setFullYear(baseDt.getFullYear() + Number(found[2]));
                            }
                        } else if ('rand' === mods[_key]) {
                            baseDt.setFullYear(getRandomInt(1, new Date().getFullYear()));
                        } else {
                            baseDt.setFullYear(Number(mods[_key]));
                        }
                        break;
                    case /^mon(|ths?)$/i.test(_key):
                        if (typeof mods[_key] === 'string' && /^(-|\+)\d+$/i.test(mods[_key])) {
                            found = mods[_key].match(/^(-|\+)(\d+)$/);
                            if (found[1] === '-') {
                                baseDt.setMonth(baseDt.getMonth() - Number(found[2]));
                            } else {
                                baseDt.setMonth(baseDt.getMonth() + Number(found[2]));
                            }
                        } else if ('rand' === mods[_key]) {
                            baseDt.setMonth(getRandomInt(0, 11));
                        } else {
                            baseDt.setMonth(Number(mods[_key]) == 12 ? 11 : Number(mods[_key]));
                        }
                        break;
                    case /^d(|ays?)$/i.test(_key):
                        if (typeof mods[_key] === 'string' && /^(-|\+)\d+$/i.test(mods[_key])) {
                            found = mods[_key].match(/^(-|\+)(\d+)$/);
                            if (found[1] === '-') {
                                baseDt.setDate(baseDt.getDate() - Number(found[2]));
                            } else {
                                baseDt.setDate(baseDt.getDate() + Number(found[2]));
                            }
                        } else if ('rand' === mods[_key]) {
                            baseDt.setDate(getRandomInt(1, 31));
                        } else {
                            baseDt.setDate(Number(mods[_key]));
                        }
                        break;
                    case /^h(|ours?)$/i.test(_key):
                        if (typeof mods[_key] === 'string' && /^(-|\+)\d+$/i.test(mods[_key])) {
                            found = mods[_key].match(/^(-|\+)(\d+)$/);
                            if (found[1] === '-') {
                                baseDt.setHours(baseDt.getHours() - Number(found[2]));
                            } else {
                                baseDt.setHours(baseDt.getHours() + Number(found[2]));
                            }
                        } else if ('rand' === mods[_key]) {
                            baseDt.setHours(getRandomInt(0, 23));
                        } else {
                            baseDt.setHours(Number(mods[_key]));
                        }
                        break;
                    case /^min(|utes?)$/i.test(_key):
                        if (typeof mods[_key] === 'string' && /^(-|\+)\d+$/i.test(mods[_key])) {
                            found = mods[_key].match(/^(-|\+)(\d+)$/);
                            if (found[1] === '-') {
                                baseDt.setMinutes(baseDt.getMinutes() - Number(found[2]));
                            } else {
                                baseDt.setMinutes(baseDt.getMinutes() + Number(found[2]));
                            }
                        } else if ('rand' === mods[_key]) {
                            baseDt.setMinutes(getRandomInt(0, 59));
                        } else {
                            baseDt.setMinutes(Number(mods[_key]));
                        }
                        break;
                    case /^s(|(ec|onds?))$/i.test(_key):
                        if (typeof mods[_key] === 'string' && /^(-|\+)\d+$/i.test(mods[_key])) {
                            found = mods[_key].match(/^(-|\+)(\d+)$/);
                            if (found[1] === '-') {
                                baseDt.setSeconds(baseDt.getSeconds() - Number(found[2]));
                            } else {
                                baseDt.setSeconds(baseDt.getSeconds() + Number(found[2]));
                            }
                        } else if ('rand' === mods[_key]) {
                            baseDt.setSeconds(getRandomInt(0, 59));
                        } else {
                            baseDt.setSeconds(Number(mods[_key]));
                        }
                        break;
                    default:
                        break;
                }
            }
        }
        return getDateString(baseDt);
    }
}








